#SubMatch = /<[\/]?[^:>%]*:[^>\/%]*[\/]?>/
#SubMatchOpen = /<[^:\/>%]*:[^>\/%]*>/
#SubMatchClose = /<\/[^:>%]*:[^>\/%]*>/
#SubMatchAlone = /<[^:\/>%]*:[^>\/%]*\/>/

SubMatch = /<\/?[A-Z][A-Za-z_]*:[a-z][A-Za-z_]*\s*(?:[^\/]|"[^"]*"|'[^']*')*\/?>/
SubMatchOpen = /<[A-Z][A-Za-z_]*:[a-z][A-Za-z_]*\s*.*[^\/]>/
SubMatchClose = /<\/[A-Z][A-Za-z_]*:[a-z][A-Za-z_]*\s*.*[^\/]>/
SubMatchAlone = /<[A-Z][A-Za-z_]*:[a-z][A-Za-z_]*\s*.*[^\/]\/>/

OpenASP = /(<%%)|(<%=)|(<%#)|(<%)/
CloseASP = /(%%>)|(%>)/

def makeargs( data ) 
  lf = data.gsub( /[<\/>]/, "" ).gsub( /\s*=\s*/, "=" ).split( " " )
  out = lf.shift.gsub( /:/, "::" ).gsub( /-/, "_" ) + "( { "
  sep = ""
  lf.each { |a|
    k, v = a.split( "=" )
    out += sep+"'"+k+"' => "+v
    sep = ", "
  } 
  out += " } )"
  out
end

def submatch( l )
##  l = s.split( "\n" )
  n = ""

  ignore = false
  status = 0
  name = ""

  l.each { |d| 
    
    if OpenASP.match( d )
      ignore = true
      n += d + "\n"
    elsif CloseASP.match( d )
      ignore = false
      n += d + "\n"
    elsif ignore == false
      res = nil
      while res = SubMatch.match( d )
        n += res.pre_match
    
        if SubMatchOpen.match( res[0] ) and status == 0
          name = res[0].gsub( /[<\/>]/, "" )
          status = 1
          n += "\n<% "+makeargs( res[0] )+" { ## OPEN %>\n"
        elsif SubMatchClose.match( res[0] ) and status == 1 and res[0].gsub( /[<\/>]/, "" ) == name
          name = ""
          status = 0
          n += "\n<% } ## CLOSE %>\n"
        elsif SubMatchAlone.match( res[0] ) and status == 0
          name = ""
          status = 0
          n += "\n<% "+makeargs( res[0] )+" ## ALONE %>\n"
        else
          print "OULAAAAAAAA !!! status = *",status,"* / name = *",name,"*\n"
        end
    
        d = res.post_match
      end
      unless res.nil?
        n += res.post_match
      else
        n += d + "\n"
      end
    else
      n += d + "\n"
    end

  }

  n
end
